//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
    srand((unsigned int) time(0));
    generate(500);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::generate(int times)
{
    byte x[edge];
    byte y[edge];
    bool yline;
    bool xline;
    FILE *fp;
    if ((fp = fopen("output.txt","w")) == NULL)
    {
        fprintf(stderr,"Cannot open file.");
        exit(1);
    }
    for (int i =0,yline=false,xline=false; i < times; i++)
    {
        /* Clear the canvas  */
        Image1->Canvas->Brush->Color = clWhite;
        Image1->Canvas->FillRect(Rect(0,0,Image1->ClientWidth,Image1->ClientHeight));
        /* generator trigular */
        for(byte j = 0; j < edge; j++)
        {
            y[j] = random(Image1->ClientHeight);
            generateX(x,y,j);
        /* check line*/
            switch (j)
            {
                case 0:
                   break;
                case 1:
                   if (y[j] == y[0])
                   {
                       xline = true;
                       while(x[j] == x[0])
                       {
                          generateX(x,y,j);
                       }
                   }
                   else if(x[j] == x[0])
                   {
                       yline = true;
                   }
                   break;
                case 2:
                   while (xline && y[j] == y[j-1])
                   {
                       y[j] = random(Image1->ClientHeight);
                       generateX(x,y,j);
                   }
                   while (yline && x[j] == x[j-1])
                   {
                       generateX(x,y,j);
                   }
                   break;
                default:
                   break;
            }
        }
        if ((!xline) && (!yline))
        {
            /*1st point is the same to 3rd*/
            while((x[2] == x[0]) && (y[2] == y[0]))
                generateX(x,y,2);
            /*2nd point is the same to 3rd*/
            while((x[2] == x[1]) && (y[2] == y[1]))
                generateX(x,y,2);
        }
        /* line up and save */
        for(byte j = 0; j < edge; j++)
        {
            Image1->Canvas->MoveTo(x[j%edge],y[j%edge]);
            Image1->Canvas->LineTo(x[(j+1)%edge],y[(j+1)%edge]);
        }
        /* wirte to file*/
        fprintf(fp,"%d.",i+1);
        for(byte j = 0; j < edge; j++)
        {
            fprintf(fp,"(%d,%d)",x[j],y[j]);
        }
        fprintf(fp,"\n");
        /* save to file */
        Image1->Picture->SaveToFile(AnsiString(i+1)+".bmp");
        /*clear array*/
        for(byte j = 0; j < edge; j++)
        {
            x[j] = Image1->ClientWidth;
            y[j] = Image1->ClientHeight;
        }
    }
    ShowMessage("Done!");
}

void __fastcall TForm1::generateX(byte *x, byte *y, int j)
{
    if (y[j] == 0 || y[j] == (Image1->ClientHeight-1))
        x[j] = random(Image1->ClientWidth);
    else if(rand()%2)
        x[j] = 0;
    else
        x[j] = Image1->ClientWidth-1;
}
